com.ihr.xbrl.dts

## Class PeriodMember

- java.lang.Object
- - com.ihr.xbrl.dts.PeriodMember

- All Implemented Interfaces:
    Member<ColumnPeriod>, java.io.Serializable, java.lang.Cloneable

      public class PeriodMember
      extends java.lang.Object
      implements Member<ColumnPeriod>

  The Class PeriodMember.
  Author:
    Ignacio
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PeriodMember(ColumnPeriod cp, Dimension<?> dim)` Instantiates a new period member.
    `PeriodMember(XBRLPeriod period, HasBoySupport hb, Dimension<?> dim, HandleDateStep.InstantMode instantMode)` Instantiates a new period member.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addDomain(java.util.Collection<Member<?>> members)` Adds a domain of members.
    `void` | `addPeriod(XBRLPeriod period)` Adds a new XBRLPeriod to this column of periods.
    `Member<ColumnPeriod>` | `clone()` Clone constructor.
    `int` | `compareTo(Member<?> o2)` Compare to.
    `boolean` | `equals(java.lang.Object obj)`
    `Dimension<?>` | `getDimension()` Access back to the dimensions this member has belongs to.
    `java.util.Collection<Member<?>>` | `getDomain()` Returns the available sub members of this member.
    `ColumnPeriod` | `getMember()` Access to the member.
    `XBRLPeriod` | `getPeriod()` If this PeriodMember contains only one XBRLPeriod object this method returns it.
    `boolean` | `hasDomain()` Returns true if the member is a Domain and has sub-members.
    `int` | `hashCode()`
    `boolean` | `isAbstract()` This method returns true if the member associated is abstract.
    `boolean` | `isNegated()` Negated are shown in red color font.
    `boolean` | `isNet()` Nets are shown in bold font.
    `boolean` | `isPrimary()` This method returns true if the member is a primary item, otherwise is a dimension member of either an XDT dimension or a Virtual dimension.
    `boolean` | `isTotal()` Totals are shown in bold font.
    `boolean` | `isVisible()` Must return true if the member is going to be visualized in rows or columns.
    `Dimension<?>` | `setDimension(Dimension<?> newDimension)` Set or change the assigned dimension of this member
    `void` | `setHidden()` Sets the hidden.
    `void` | `setVisible()` Sets the visible.
    `void` | `setVisible(boolean value)` Sets the visibility parameter value for this member.
    `XBRLPeriod` | `toPeriod(DTSContainer container, XBRLItem.PeriodType type, HandleDateStep.InstantMode mode)` To period.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### PeriodMember

          public PeriodMember(XBRLPeriod period,
                      HasBoySupport hb,
                      Dimension<?> dim,
                      HandleDateStep.InstantMode instantMode)

      Instantiates a new period member.
      Parameters:
        `period` - the period
        `hb` - the hb
        `dim` - the dim
        `instantMode` - the instant mode

    - #### PeriodMember

          public PeriodMember(ColumnPeriod cp,
                      Dimension<?> dim)

      Instantiates a new period member.
      Parameters:
        `cp` - the cp
        `dim` - the dim

  - ### Method Detail

    - #### addPeriod

          public void addPeriod(XBRLPeriod period)

      Adds a new XBRLPeriod to this column of periods. Only XBRLPeriods inside this column will be added.
      Parameters:
        `period` - the period

    - #### getPeriod

          public XBRLPeriod getPeriod()

      If this PeriodMember contains only one XBRLPeriod object this method returns it. Otherwise this method returns null.

      This method is used when the PeriodMember has been created from one XBRLPeriod but has not been added to a PeriodDimension yet. At the time it is added to the PeriodDimension the XBRLPeriod is obtained in order to add the XBRLPeriod to an existing ColumnPeriod if it already exists.

      Returns:
        XBRLPeriod or null

    - #### clone

          public Member<ColumnPeriod> clone()

      Description copied from interface: `Member`
      Clone constructor.
      Specified by:
        `clone` in interface `Member<ColumnPeriod>`
      Overrides:
        `clone` in class `java.lang.Object`
      Returns:
        the member

    - #### getMember

          public ColumnPeriod getMember()

      Description copied from interface: `Member`
      Access to the member.
      Specified by:
        `getMember` in interface `Member<ColumnPeriod>`
      Returns:
        element of the class of the Member type

    - #### getDomain

          public java.util.Collection<Member<?>> getDomain()

      Description copied from interface: `Member`
      Returns the available sub members of this member. In the case there were no sub-members the function returns null.
      Specified by:
        `getDomain` in interface `Member<ColumnPeriod>`
      Returns:
        Collection of sub members of class T
      See Also:
        `Member.hasDomain()`

    - #### hasDomain

          public boolean hasDomain()

      Description copied from interface: `Member`
      Returns true if the member is a Domain and has sub-members.
      Specified by:
        `hasDomain` in interface `Member<ColumnPeriod>`
      Returns:
        boolean value

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### addDomain

          public void addDomain(java.util.Collection<Member<?>> members)

      Description copied from interface: `Member`
      Adds a domain of members. This method should be called only if the member has no domain. This method should use the clone<T> method for adding copies of the members that are passed as parameter
      Specified by:
        `addDomain` in interface `Member<ColumnPeriod>`
      Parameters:
        `members` - the members

    - #### isAbstract

          public boolean isAbstract()

      Description copied from interface: `Member`
      This method returns true if the member associated is abstract.
      Specified by:
        `isAbstract` in interface `Member<ColumnPeriod>`
      Returns:
        boolean

    - #### isPrimary

          public boolean isPrimary()

      Description copied from interface: `Member`
      This method returns true if the member is a primary item, otherwise is a dimension member of either an XDT dimension or a Virtual dimension.
      Specified by:
        `isPrimary` in interface `Member<ColumnPeriod>`
      Returns:
        true, if is primary

    - #### isVisible

          public boolean isVisible()

      Description copied from interface: `Member`
      Must return true if the member is going to be visualized in rows or columns. If false, the member will be hidden and all children elements too
      Specified by:
        `isVisible` in interface `Member<ColumnPeriod>`
      Returns:
        boolean value

    - #### setVisible

          public void setVisible()

      Sets the visible.

    - #### setVisible

          public void setVisible(boolean value)

      Description copied from interface: `Member`
      Sets the visibility parameter value for this member.
      Specified by:
        `setVisible` in interface `Member<ColumnPeriod>`
      Parameters:
        `value` - the new visible

    - #### setHidden

          public void setHidden()

      Sets the hidden.

    - #### getDimension

          public Dimension<?> getDimension()

      Description copied from interface: `Member`
      Access back to the dimensions this member has belongs to.
      Specified by:
        `getDimension` in interface `Member<ColumnPeriod>`
      Returns:
        the dimension

    - #### setDimension

          public Dimension<?> setDimension(Dimension<?> newDimension)

      Description copied from interface: `Member`
      Set or change the assigned dimension of this member
      Specified by:
        `setDimension` in interface `Member<ColumnPeriod>`
      Parameters:
        `newDimension` - the new dimension
      Returns:
        the previouly assigned dimension or null

    - #### toPeriod

          public XBRLPeriod toPeriod(DTSContainer container,
                            XBRLItem.PeriodType type,
                            HandleDateStep.InstantMode mode)

      To period.
      Parameters:
        `container` - the container
        `type` - the type
        `mode` - the mode
      Returns:
        the XBRL period

    - #### compareTo

          public int compareTo(Member<?> o2)

      Description copied from interface: `Member`
      Compare to.
      Specified by:
        `compareTo` in interface `Member<ColumnPeriod>`
      Parameters:
        `o2` - the o2
      Returns:
        the int

    - #### isTotal

          public boolean isTotal()

      Description copied from interface: `Member`
      Totals are shown in bold font. This method returns true when the item is assigned to a total role
      Specified by:
        `isTotal` in interface `Member<ColumnPeriod>`
      Returns:
        true, if is total

    - #### isNet

          public boolean isNet()

      Description copied from interface: `Member`
      Nets are shown in bold font. This method returns true when the item is assigned the net role
      Specified by:
        `isNet` in interface `Member<ColumnPeriod>`
      Returns:
        true, if is net

    - #### isNegated

          public boolean isNegated()

      Description copied from interface: `Member`
      Negated are shown in red color font. This method returns true when the item is assigned to a negated role
      Specified by:
        `isNegated` in interface `Member<ColumnPeriod>`
      Returns:
        true, if is negated